--  Light Cycles v1.00
--  A Naked Temple Product
--
--
--

include graphics.e
include get.e
include image.e


-- Game abort procedure, if user presses Esc
procedure gameab()
    puts(1,"Game abort")
end procedure

-- Human Player wins
procedure p1win()
    position(10,10)
    puts(1, "Human player wins")
end procedure

--Computer Player Wins
procedure p2win()
    position(10,10)
    puts(1, "Computer player wins")
end procedure

-- Open Screen
clear_screen()
if graphics_mode(18) then
   puts(1, "cannot open screen")
end if

-- Initialise variables
constant UP=1,DOWN=3,LEFT=4,RIGHT=2

atom tx,tx1,gamspd

gamspd = 0.00001
integer gameon , p1x , p1y , p1d
gameon=1
p1x=rand(150)
p1y=rand(250)
p1d=LEFT

integer p2x , p2y , p2d
p2x=rand(150)+10
p2y=rand(250)+10
p2d=rand(3)+1
integer p1c , p2c, i
	    
sequence mapx   
	    
tx=time()           
	    
-- Display Title Screen         
mapx=read_bitmap("gamettl.bmp")
display_image({0,0},mapx[2])
position(15,28)
puts(1,"Press any key to play")
position(25,20)
puts(1,"Use arrow keys to control green cycle")

while get_key()=-1 do
end while           

clear_screen()

-- Setup screen for gameplay
i=graphics_mode(19) 
draw_line(RED,{{0,0},{310,0},{310,190},{0,190},{0,0}})          

--Main Game Loop           
while gameon  do
    -- Collision Detection for both players
    p1c=get_pixel({p1y,p1x})
    p2c=get_pixel({p2y,p2x})
    if p1c!=0 then
	p2win()
	gameon=0
    end if
    if p2c!=0 then
	p1win()
	gameon=0
    end if
    -- Plot Lightcycles
    pixel(GREEN,{p1y,p1x})
    pixel(BLUE,{p2y,p2x})
   -- Move Human Player
   if p1d=UP and p1x>1 then
	p1x=p1x-1
    end if
    if p1d=DOWN and p1x<199 then
       p1x=p1x+1
    end if
    if p1d=LEFT and p1y<319 then
       p1y=p1y+1
    end if
    if p1d=RIGHT and p1y>1 then
     p1y=p1y-1
    end if
  -- Move Computer Player   
  if p2d=UP and p2x>1 then
      p2x=p2x-1
  end if
  if p2d=DOWN and p2x<199 then
     p2x=p2x+1
  end if
  if p2d=LEFT and p2y<319 then
   p2y=p2y+1
  end if
  if p2d=RIGHT and p2y>1 then
   p2y=p2y-1
  end if
  -- Computer Player Intelligence
    if p2d=UP then
	if get_pixel({p2y,p2x-2})!=0  then
	    position (14,1)
	    if get_pixel({p2y-1,p2x})=0 then
		p2d=LEFT
	    else
		p2d=RIGHT   
	    end if
	end if      
    end if
    if p2d=DOWN then
	if get_pixel({p2y,p2x+2})!=0 then
	    if get_pixel({p2y-1,p2x})=0 then
		p2d=RIGHT
	    else
		p2d=LEFT
	    end if
	end if
    end if
    if p2d=RIGHT then
	if get_pixel({p2y-2,p2x})!=0  then
	    if get_pixel({p2x,p2y-1})=0 then
	       p2d=UP
	    else
	       p2d=DOWN 
	    end if
	end if
    end if 
    if p2d=LEFT then
	if get_pixel({p2y+2,p2x})!=0 then
	    if get_pixel({p2y,p2x+1})=0 then
		p2d=DOWN
	    else
		p2d=UP  
	    end if
	end if
    end if
    -- Get user Keypress
    i=get_key()
    if i=27 then
	gameab()
	gameon=0
    end if
    if i=328 then
	p1d=UP
    end if
    if i=333 then
	p1d=LEFT
    end if
    if i=336 then
	p1d=DOWN
    end if
    if i=331 then
	p1d=RIGHT
    end if
    --Game Speed Control
    tx1=time()
    while tx1 < tx + gamspd do
    tx1=time()
    end while
    tx=time()
end while
-- Restore Screen and exit program      
while get_key()=-1 do
end while
if graphics_mode(-1) then
end if
